<template>
  <div >
    <EmployeeInfo
      v-bind.sync="employee"
      v-on:submit="submit"
      v-bind:loading="loading"
    >
    </EmployeeInfo>
  </div>
</template>

<script>
import EmployeeInfo from '@/components/employeePanel/EmployeeInfo.vue';
import { getAuthenticatedUser } from '@/fb';
import { mapGetters } from 'vuex';
import Employee from '@/models/UserInformation';
// eslint-disable-next-line import/no-cycle
import { getCurrentUser } from '@/firebase/db';

export default {
  components: {
    EmployeeInfo,
  },
  data() {
    return {
      employee: new Employee(),
      loading: false,
    };
  },
  props: {
  },
  computed: {
    ...mapGetters({
      snackbarText: 'getSnackbarText',
      showSnackbar: 'getShowSnackbar',
      user: 'getUser',
    }),
  },
  mounted() {
    getAuthenticatedUser().then((user) => {
      this.employee.uid = user.uid;
      this.employee.id = user.uid;
      console.log('this is note ID', this.employee.id);
      this.employee.fetch();
    });
  },
  methods: {
    submit() {
      this.loading = true;
      this.employee.update().then(() => {
        getCurrentUser().updateProfile({
          displayName: `${this.employee.firstname} ${this.employee.lastname}`,
        }).then(() => {
          console.log('Done creating note', this.employee.id);
          this.$store.dispatch('setSnackbarText', 'Updated your profile');
          this.$store.dispatch('setShowSnackbar', true);
          this.loading = false;
        }).catch((error) => {
          this.$store.dispatch('setSnackbarText', error.message);
          this.$store.dispatch('setShowSnackbar', true);
          this.loading = false;
        });
      });
    },
  },
};
</script>
